This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours

Bug 838780 (ghc-shakespeare-text)

Summary: Review Request: ghc-shakespeare-text - Interpolation with quasi-quotation
Product: [Fedora] Fedora Reporter: Ben Boeckel <mathstuf>
Component: Package ReviewAssignee: Jens Petersen <petersen>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: haskell-devel, notting, package-review
Target Milestone: ---Flags: petersen: fedora‑review+
limburgher: fedora‑cvs+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: ghc-shakespeare-text-1.0.0.5-1.fc18 Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2013-07-02 21:41:50 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On:    
Bug Blocks: 630303, 634048, 827975, 839234    

Description Ben Boeckel 2012-07-10 01:29:52 EDT
Spec URL: http://benboeckel.net/packaging/ghc-shakespeare-text/ghc-shakespeare-text.spec
SRPM URL: http://benboeckel.net/packaging/ghc-shakespeare-text/ghc-shakespeare-text-1.0.0.2-1.fc18.src.rpm
Description:
Interpolation with quasi-quotation: stick haskell variables into haskell strings.

Note there is no dependency on haskell-src-extras. If you don't mind that dependency, you may want to look at using these packages: Interpolation, interpolatedstring-perl6, interpolatedstring-qq.

This package has 1 other general feature that those others may not (but would be easy to duplicate): instead of using quasi-quoting you can also use an external file. It also has url/embeding interpolation, with \@ and \^, which are used in Yesod.

This package also uses blaze-builder for efficiently constructing strings (I am not sure what the other packages use). This might be of interest to you for large templates or performance sensitive code, or otherwise having a nice interface to blaze-builder.

Shakespeare is a template family for type-safe, efficient templates with simple variable interpolation . Shakespeare templates can be used inline with a quasi-quoter or in an external file. Shakespeare interpolates variables according to the type being inserted. In this case, the variable type needs a ToText instance.

Please see http://docs.yesodweb.com/book/templates for a more thorough description and examples of the shakespeare family of template languages.

Fedora Account System Username: mathstuf

% lintmock fedora-rawhide-x86_64
ghc-shakespeare-text.src: W: spelling-error %description -l en_US haskell -> Haskell
ghc-shakespeare-text.src: W: spelling-error %description -l en_US src -> arc, sec, sic
ghc-shakespeare-text.src: W: spelling-error %description -l en_US interpolatedstring -> interpolated string, interpolated-string, interpolating
ghc-shakespeare-text.src: W: spelling-error %description -l en_US qq -> q, sqq, sq
ghc-shakespeare-text.src: W: spelling-error %description -l en_US url -> URL, curl, purl
ghc-shakespeare-text.src: W: spelling-error %description -l en_US embeding -> embedding, bedimming, bedding
ghc-shakespeare-text.src: W: spelling-error %description -l en_US quoter -> quote, quotes, quoted
ghc-shakespeare-text.src: W: strange-permission shakespeare-text-1.0.0.2.tar.gz 0640L
ghc-shakespeare-text.src: W: strange-permission ghc-shakespeare-text.spec 0640L
ghc-shakespeare-text.x86_64: W: spelling-error %description -l en_US haskell -> Haskell
ghc-shakespeare-text.x86_64: W: spelling-error %description -l en_US src -> arc, sec, sic
ghc-shakespeare-text.x86_64: W: spelling-error %description -l en_US interpolatedstring -> interpolated string, interpolated-string, interpolating
ghc-shakespeare-text.x86_64: W: spelling-error %description -l en_US qq -> q, sqq, sq
ghc-shakespeare-text.x86_64: W: spelling-error %description -l en_US url -> URL, curl, purl
ghc-shakespeare-text.x86_64: W: spelling-error %description -l en_US embeding -> embedding, bedimming, bedding
ghc-shakespeare-text.x86_64: W: spelling-error %description -l en_US quoter -> quote, quotes, quoted
ghc-shakespeare-text-devel.x86_64: W: spelling-error %description -l en_US haskell -> Haskell
ghc-shakespeare-text-devel.x86_64: W: spelling-error %description -l en_US interpolatedstring -> interpolated string, interpolated-string, interpolating
ghc-shakespeare-text-devel.x86_64: W: spelling-error %description -l en_US qq -> q, sqq, sq
ghc-shakespeare-text-devel.x86_64: W: spelling-error %description -l en_US url -> URL, curl, purl
ghc-shakespeare-text-devel.x86_64: W: spelling-error %description -l en_US embeding -> embedding, bedimming, bedding
ghc-shakespeare-text-devel.x86_64: W: spelling-error %description -l en_US quoter -> quote, quotes, quoted
3 packages and 0 specfiles checked; 0 errors, 22 warnings.
Comment 1 Jens Petersen 2012-07-10 03:56:26 EDT
I think the description is probably too verbose and could be cropped a bit
but of course looks fine so far.
Comment 2 Jens Petersen 2012-09-13 06:41:17 EDT
Latest version is now 1.0.0.4.
Comment 3 Jens Petersen 2013-03-11 05:51:01 EDT
License should be MIT.
Comment 4 Jens Petersen 2013-03-11 05:53:09 EDT
I think the colon (:) should be removed from the Summary too.
Comment 5 Jens Petersen 2013-06-07 00:34:11 EDT
ping! :)
Comment 6 Jens Petersen 2013-06-16 22:38:53 EDT
Any change you could update this?

(latest release is now 1.0.0.5 btw.)
Comment 8 Jens Petersen 2013-06-17 03:09:18 EDT
Thanks - looks okay now.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Static libraries in -static subpackage, if present.
  Note: Archive *.a files found in ghc-shakespeare-text-devel
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#StaticLibraries

This is normal for Haskell ghc libraries.

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Fully versioned dependency in subpackages, if present.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in ghc-
     shakespeare-text-devel
[x]: Package complies to the Packaging Guidelines
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. No licenses
     found. Please check the source files for licenses manually.
[x]: License file installed when any subpackage combination is installed.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
[x]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 122880 bytes in 17 files.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[-]: %check is present and all tests pass.
[?]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: ghc-shakespeare-text-1.0.0.5-1.fc20.x86_64.rpm
          ghc-shakespeare-text-devel-1.0.0.5-1.fc20.x86_64.rpm
ghc-shakespeare-text.x86_64: W: spelling-error %description -l en_US haskell -> Haskell
ghc-shakespeare-text.x86_64: W: spelling-error %description -l en_US src -> arc, sec, sic
ghc-shakespeare-text.x86_64: W: spelling-error %description -l en_US interpolatedstring -> interpolated string, interpolated-string, interpolating
ghc-shakespeare-text.x86_64: W: spelling-error %description -l en_US qq -> q, sqq, sq
ghc-shakespeare-text.x86_64: W: spelling-error %description -l en_US url -> URL, curl, purl
ghc-shakespeare-text.x86_64: W: spelling-error %description -l en_US embeding -> embedding, bedimming, bedding
ghc-shakespeare-text.x86_64: W: spelling-error %description -l en_US quoter -> quote, quotes, quoted
2 packages and 0 specfiles checked; 0 errors, 7 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint ghc-shakespeare-text-devel ghc-shakespeare-text
ghc-shakespeare-text.x86_64: W: spelling-error %description -l en_US haskell -> Haskell
ghc-shakespeare-text.x86_64: W: spelling-error %description -l en_US src -> arc, sec, sic
ghc-shakespeare-text.x86_64: W: spelling-error %description -l en_US interpolatedstring -> interpolated string, interpolated-string, interpolating
ghc-shakespeare-text.x86_64: W: spelling-error %description -l en_US qq -> q, sqq, sq
ghc-shakespeare-text.x86_64: W: spelling-error %description -l en_US url -> URL, curl, purl
ghc-shakespeare-text.x86_64: W: spelling-error %description -l en_US embeding -> embedding, bedimming, bedding
ghc-shakespeare-text.x86_64: W: spelling-error %description -l en_US quoter -> quote, quotes, quoted
2 packages and 0 specfiles checked; 0 errors, 7 warnings.
# echo 'rpmlint-done:'



Requires
--------
ghc-shakespeare-text-devel (rpmlib, GLIBC filtered):
    /bin/sh
    ghc(shakespeare-text-1.0.0.5-2c8596c39ac71d2cafd87fb629549600)
    ghc-compiler
    ghc-devel(base-4.5.1.0-6e4c9bdc36eeb9121f27ccbbcb62e3f3)
    ghc-devel(shakespeare-1.0.3.1-84bad792768cd28bba12368b29a1b5eb)
    ghc-devel(template-haskell-2.7.0.0-2bd128e15c2d50997ec26a1eaf8b23bf)
    ghc-devel(text-0.11.2.3-db61832d0c4660614c4ceff234ed4abb)
    ghc-shakespeare-text

ghc-shakespeare-text (rpmlib, GLIBC filtered):
    ghc(base-4.5.1.0-6e4c9bdc36eeb9121f27ccbbcb62e3f3)
    ghc(shakespeare-1.0.3.1-84bad792768cd28bba12368b29a1b5eb)
    ghc(template-haskell-2.7.0.0-2bd128e15c2d50997ec26a1eaf8b23bf)
    ghc(text-0.11.2.3-db61832d0c4660614c4ceff234ed4abb)
    libHSarray-0.4.0.0-ghc7.4.2.so()(64bit)
    libHSbase-4.5.1.0-ghc7.4.2.so()(64bit)
    libHSbytestring-0.9.2.1-ghc7.4.2.so()(64bit)
    libHScontainers-0.4.2.1-ghc7.4.2.so()(64bit)
    libHSdeepseq-1.3.0.0-ghc7.4.2.so()(64bit)
    libHSdirectory-1.1.0.2-ghc7.4.2.so()(64bit)
    libHSfilepath-1.3.0.0-ghc7.4.2.so()(64bit)
    libHSghc-prim-0.2.0.0-ghc7.4.2.so()(64bit)
    libHSinteger-gmp-0.4.0.0-ghc7.4.2.so()(64bit)
    libHSmtl-2.1.2-ghc7.4.2.so()(64bit)
    libHSold-locale-1.0.0.4-ghc7.4.2.so()(64bit)
    libHSold-time-1.1.0.0-ghc7.4.2.so()(64bit)
    libHSparsec-3.1.3-ghc7.4.2.so()(64bit)
    libHSpretty-1.1.1.0-ghc7.4.2.so()(64bit)
    libHSprocess-1.1.0.1-ghc7.4.2.so()(64bit)
    libHSshakespeare-1.0.3.1-ghc7.4.2.so()(64bit)
    libHStemplate-haskell-2.7.0.0-ghc7.4.2.so()(64bit)
    libHStext-0.11.2.3-ghc7.4.2.so()(64bit)
    libHStransformers-0.3.0.0-ghc7.4.2.so()(64bit)
    libHSunix-2.5.1.1-ghc7.4.2.so()(64bit)
    libc.so.6()(64bit)
    libdl.so.2()(64bit)
    libgmp.so.10()(64bit)
    libpthread.so.0()(64bit)
    librt.so.1()(64bit)
    libutil.so.1()(64bit)
    rtld(GNU_HASH)



Provides
--------
ghc-shakespeare-text-devel:
    ghc-devel(shakespeare-text-1.0.0.5-2c8596c39ac71d2cafd87fb629549600)
    ghc-shakespeare-text-devel
    ghc-shakespeare-text-devel(x86-64)

ghc-shakespeare-text:
    ghc(shakespeare-text-1.0.0.5-2c8596c39ac71d2cafd87fb629549600)
    ghc-shakespeare-text
    ghc-shakespeare-text(x86-64)
    libHSshakespeare-text-1.0.0.5-ghc7.4.2.so()(64bit)



Unversioned so-files
--------------------
ghc-shakespeare-text: /usr/lib64/ghc-7.4.2/shakespeare-text-1.0.0.5/libHSshakespeare-text-1.0.0.5-ghc7.4.2.so

Source checksums
----------------
http://hackage.haskell.org/packages/archive/shakespeare-text/1.0.0.5/shakespeare-text-1.0.0.5.tar.gz :
  CHECKSUM(SHA256) this package     : 669c298fbb7a06b667299f9ca185f32645d36aec13d9af6fb70e403d48ffde9c
  CHECKSUM(SHA256) upstream package : 669c298fbb7a06b667299f9ca185f32645d36aec13d9af6fb70e403d48ffde9c


Generated by fedora-review 0.4.1 (b2e211f) last change: 2013-04-29
Buildroot used: fedora-rawhide-x86_64
Command line :/usr/bin/fedora-review -b 838780


APPROVED.
Comment 9 Ben Boeckel 2013-06-17 13:35:00 EDT
New Package SCM Request
=======================
Package Name: ghc-shakespeare-text
Short Description: Interpolation with quasi-quotation
Owners: mathstuf
Branches: f18 f19
InitialCC: haskell-sig
Comment 10 Jon Ciesla 2013-06-17 13:38:11 EDT
Git done (by process-git-requests).
Comment 11 Fedora Update System 2013-06-24 02:20:01 EDT
ghc-shakespeare-text-1.0.0.5-1.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/ghc-shakespeare-text-1.0.0.5-1.fc18
Comment 12 Fedora Update System 2013-06-24 02:20:15 EDT
ghc-shakespeare-text-1.0.0.5-1.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/ghc-shakespeare-text-1.0.0.5-1.fc19
Comment 13 Fedora Update System 2013-06-24 14:51:17 EDT
ghc-shakespeare-text-1.0.0.5-1.fc19 has been pushed to the Fedora 19 testing repository.
Comment 14 Fedora Update System 2013-07-02 21:41:50 EDT
ghc-shakespeare-text-1.0.0.5-1.fc19 has been pushed to the Fedora 19 stable repository.
Comment 15 Fedora Update System 2013-07-03 20:59:50 EDT
ghc-shakespeare-text-1.0.0.5-1.fc18 has been pushed to the Fedora 18 stable repository.